SystemOrganization addCategory: #'Glamour-Roassal-Presentations'!

!GLMCompositePresentation methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 5/5/2012 14:35'!
roassal
	^ self custom: GLMRoassalPresentation new! !

GLMPresentation subclass: #GLMRoassalPresentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal-Presentations'!

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 12:09'!
bitmap 
	^ self view bitmap ! !

!GLMRoassalPresentation methodsFor: 'scripting' stamp: 'TudorGirba 6/5/2013 22:18'!
defaultActions
	self
		act: [ :roassal | ROExportPNGCommand new executeOn: roassal view raw ] 
			entitled: 'Export as PNG';
		act: [ :roassal | ROZoomOutMove new on: roassal view raw ]
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
		act: [ :roassal | ROZoomInMove new on: roassal view raw ]
			icon: MondrianIcons mondrianZoomIn
			entitled: 'Zoom in'! !

!GLMRoassalPresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 9/9/2012 21:08'!
initialize 
	super initialize.
	shouldPopulateSelection := true! !

!GLMRoassalPresentation methodsFor: 'scripting' stamp: 'TudorGirba 5/7/2012 14:10'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 14:10'!
paintingBlock
	^ paintingBlock! !

!GLMRoassalPresentation methodsFor: 'rendering' stamp: 'TudorGirba 5/7/2012 14:13'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassalPresentation: self! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/7/2012 22:48'!
renderOn: aView
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self paintingBlock glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aView with: self entity with: self]).
	self flag: 'This should be the responsibility of the the view'.
	aView applyLayout.	
	aView populateMenuOn: aView stack.
	self shouldPopulateSelection ifTrue: [
		aView raw allElementsDo: [:each | 
			each on: ROMouseClick do: [:event | self selection: each model ]] ].
	self view: aView! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/9/2012 21:09'!
shouldPopulateSelection
	"this flag tells the presentation whether clicking on some element inside
	the view should populate the selection port from the pane containing the presentation"
	^ shouldPopulateSelection! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/9/2012 20:16'!
shouldPopulateSelection: anObject
	shouldPopulateSelection := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 6/5/2012 17:11'!
view
	^ view ifNil: [view := ROMondrianViewBuilder new]! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'TudorGirba 5/7/2012 14:11'!
view: anObject
	view := anObject! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 5/31/2013 09:57'!
asBrowserWithStatusbar
	| browser |
	browser := GLMTabulator withStatusbar.
	browser title: 'Roassal painting'.
	browser column: #painting.
	browser 
			act: [:b | (b paneNamed: #painting) presentations first canvas exportAsPNG] entitled: 'Export as PNG';
			act: [:b | 
				(b paneNamed: #painting) presentations first canvas root decreaseZoom.
				(b paneNamed: #painting) presentations first canvas changed ] 
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
			act: [:b | 
				(b paneNamed: #painting) presentations first canvas root increaseZoom.
				(b paneNamed: #painting) presentations first canvas root updateWindow ] 
			icon: MondrianIcons mondrianZoomIn 
			entitled: 'Zoom in'.
	browser transmit to: #painting; andShow: [ :a | 
		a roassal view: self ].
	^ browser! !

!ROMondrianViewBuilder methodsFor: '*glamour-roassal-presentations' stamp: 'TudorGirba 5/31/2013 09:56'!
openWithStatusbar
	^ self asBrowserWithStatusbar openOn: self! !
